package org.example.data

import org.example.data.model.UserDTO

class UserRepositoryImpl: UserRepository {
    private val userSource: MutableList<UserDTO> = userList.toMutableList()

    override fun addUser() {
        TODO("Not yet implemented")
    }

    override fun removeUserById(userId: Int): Boolean {
       return userSource.removeIf { it.userId == userId }
    }

    override fun updateUserById(userId: Int, newUser: UserDTO): UserDTO {
        val oldUser = userSource.first { it.userId == userId }
        oldUser.phone = newUser.phone
        oldUser.address = newUser.address
        oldUser.firstName = newUser.firstName
        oldUser.lastName = newUser.lastName
        oldUser.password = newUser.password
        return oldUser
    }

    override fun getAllUsers(): List<UserDTO> = userList

    override fun findUserById(userId: Int): UserDTO {
        val findUser = userList.firstOrNull { it.userId == userId }
        checkNotNull(findUser)
        return findUser
    }
}